# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class RouteEntry(pulumi.CustomResource):
    """
    Provides a CEN route entry resource. Cloud Enterprise Network (CEN) supports publishing and withdrawing route entries of attached networks. You can publish a route entry of an attached VPC or VBR to a CEN instance, then other attached networks can learn the route if there is no route conflict. You can withdraw a published route entry when CEN does not need it any more.
    
    For information about CEN route entries publishment and how to use it, see [Manage network routes](https://www.alibabacloud.com/help/doc-detail/86980.htm).
    """
    def __init__(__self__, __name__, __opts__=None, cidr_block=None, instance_id=None, route_table_id=None):
        """Create a RouteEntry resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not cidr_block:
            raise TypeError('Missing required property cidr_block')
        elif not isinstance(cidr_block, basestring):
            raise TypeError('Expected property cidr_block to be a basestring')
        __self__.cidr_block = cidr_block
        """
        The destination CIDR block of the route entry to publish.
        """
        __props__['cidrBlock'] = cidr_block

        if not instance_id:
            raise TypeError('Missing required property instance_id')
        elif not isinstance(instance_id, basestring):
            raise TypeError('Expected property instance_id to be a basestring')
        __self__.instance_id = instance_id
        """
        The ID of the CEN.
        """
        __props__['instanceId'] = instance_id

        if not route_table_id:
            raise TypeError('Missing required property route_table_id')
        elif not isinstance(route_table_id, basestring):
            raise TypeError('Expected property route_table_id to be a basestring')
        __self__.route_table_id = route_table_id
        """
        The route table of the attached VBR or VPC.
        """
        __props__['routeTableId'] = route_table_id

        super(RouteEntry, __self__).__init__(
            'alicloud:cen/routeEntry:RouteEntry',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'cidrBlock' in outs:
            self.cidr_block = outs['cidrBlock']
        if 'instanceId' in outs:
            self.instance_id = outs['instanceId']
        if 'routeTableId' in outs:
            self.route_table_id = outs['routeTableId']
