# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class Subscription(pulumi.CustomResource):
    """
    The subscription is the basic unit of resource usage in Datahub Service under Publish/Subscribe model. You can manage the relationships between user and topics by using subscriptions. [Refer to details](https://help.aliyun.com/document_detail/47440.html).
    """
    def __init__(__self__, __name__, __opts__=None, comment=None, project_name=None, topic_name=None):
        """Create a Subscription resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if comment and not isinstance(comment, basestring):
            raise TypeError('Expected property comment to be a basestring')
        __self__.comment = comment
        """
        Comment of the datahub subscription. It cannot be longer than 255 characters.
        """
        __props__['comment'] = comment

        if not project_name:
            raise TypeError('Missing required property project_name')
        elif not isinstance(project_name, basestring):
            raise TypeError('Expected property project_name to be a basestring')
        __self__.project_name = project_name
        """
        The name of the datahub project that the subscription belongs to. Its length is limited to 3-32 and only characters such as letters, digits and '_' are allowed. It is case-insensitive.
        """
        __props__['projectName'] = project_name

        if not topic_name:
            raise TypeError('Missing required property topic_name')
        elif not isinstance(topic_name, basestring):
            raise TypeError('Expected property topic_name to be a basestring')
        __self__.topic_name = topic_name
        """
        The name of the datahub topic that the subscription belongs to. Its length is limited to 1-128 and only characters such as letters, digits and '_' are allowed. It is case-insensitive.
        """
        __props__['topicName'] = topic_name

        __self__.create_time = pulumi.runtime.UNKNOWN
        """
        Create time of the datahub subscription. It is a human-readable string rather than 64-bits UTC.
        """
        __self__.last_modify_time = pulumi.runtime.UNKNOWN
        """
        Last modify time of the datahub subscription. It is the same as *create_time* at the beginning. It is also a human-readable string rather than 64-bits UTC.
        """
        __self__.sub_id = pulumi.runtime.UNKNOWN
        """
        The identidy of the subscritpion, generate from server side.
        """

        super(Subscription, __self__).__init__(
            'alicloud:datahub/subscription:Subscription',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'comment' in outs:
            self.comment = outs['comment']
        if 'createTime' in outs:
            self.create_time = outs['createTime']
        if 'lastModifyTime' in outs:
            self.last_modify_time = outs['lastModifyTime']
        if 'projectName' in outs:
            self.project_name = outs['projectName']
        if 'subId' in outs:
            self.sub_id = outs['subId']
        if 'topicName' in outs:
            self.topic_name = outs['topicName']
