# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class Domain(pulumi.CustomResource):
    """
    Provides a DNS resource.
    
    ~> **NOTE:** The domain name which you want to add must be already registered and had not added by another account. Every domain name can only exist in a unique group.
    """
    def __init__(__self__, __name__, __opts__=None, group_id=None, name=None):
        """Create a Domain resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if group_id and not isinstance(group_id, basestring):
            raise TypeError('Expected property group_id to be a basestring')
        __self__.group_id = group_id
        """
        Id of the group in which the domain will add. If not supplied, then use default group.
        """
        __props__['groupId'] = group_id

        if name and not isinstance(name, basestring):
            raise TypeError('Expected property name to be a basestring')
        __self__.name = name
        """
        Name of the domain. This name without suffix can have a string of 1 to 63 characters, must contain only alphanumeric characters or "-", and must not begin or end with "-", and "-" must not in the 3th and 4th character positions at the same time. Suffix `.sh` and `.tel` are not supported.
        """
        __props__['name'] = name

        __self__.dns_servers = pulumi.runtime.UNKNOWN
        """
        A list of the dns server name.
        """

        super(Domain, __self__).__init__(
            'alicloud:dns/domain:Domain',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'dnsServers' in outs:
            self.dns_servers = outs['dnsServers']
        if 'groupId' in outs:
            self.group_id = outs['groupId']
        if 'name' in outs:
            self.name = outs['name']
