# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class Eip(pulumi.CustomResource):
    """
    Provides an elastic IP resource.
    
    -> **NOTE:** The resource only support to create `PayByTraffic` elastic IP for international account. Otherwise, you will happened error `COMMODITY.INVALID_COMPONENT`.
    Your account is international if you can use it to login in [International Web Console](https://account.alibabacloud.com/login/login.htm).
    
    -> **NOTE:** From version 1.10.1, this resource supports creating "PrePaid" EIP. In addition, it supports setting EIP name and description.
    """
    def __init__(__self__, __name__, __opts__=None, bandwidth=None, description=None, instance=None, instance_charge_type=None, internet_charge_type=None, name=None, period=None):
        """Create a Eip resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if bandwidth and not isinstance(bandwidth, int):
            raise TypeError('Expected property bandwidth to be a int')
        __self__.bandwidth = bandwidth
        """
        Maximum bandwidth to the elastic public network, measured in Mbps (Mega bit per second). If this value is not specified, then automatically sets it to 5 Mbps.
        """
        __props__['bandwidth'] = bandwidth

        if description and not isinstance(description, basestring):
            raise TypeError('Expected property description to be a basestring')
        __self__.description = description
        """
        Description of the EIP instance, This description can have a string of 2 to 256 characters, It cannot begin with http:// or https://. Default value is null.
        """
        __props__['description'] = description

        if instance and not isinstance(instance, basestring):
            raise TypeError('Expected property instance to be a basestring')
        __self__.instance = instance
        __props__['instance'] = instance

        if instance_charge_type and not isinstance(instance_charge_type, basestring):
            raise TypeError('Expected property instance_charge_type to be a basestring')
        __self__.instance_charge_type = instance_charge_type
        """
        Elastic IP instance charge type. Valid values are "PrePaid" and "PostPaid". Default to "PostPaid".
        """
        __props__['instanceChargeType'] = instance_charge_type

        if internet_charge_type and not isinstance(internet_charge_type, basestring):
            raise TypeError('Expected property internet_charge_type to be a basestring')
        __self__.internet_charge_type = internet_charge_type
        """
        Internet charge type of the EIP, Valid values are `PayByBandwidth`, `PayByTraffic`. Default to `PayByBandwidth`. From version `1.7.1`, default to `PayByTraffic`.
        """
        __props__['internetChargeType'] = internet_charge_type

        if name and not isinstance(name, basestring):
            raise TypeError('Expected property name to be a basestring')
        __self__.name = name
        """
        The name of the EIP instance. This name can have a string of 2 to 128 characters, must contain only alphanumeric characters or hyphens, such as "-",".","_", and must not begin or end with a hyphen, and must not begin with http:// or https://.
        """
        __props__['name'] = name

        if period and not isinstance(period, int):
            raise TypeError('Expected property period to be a int')
        __self__.period = period
        """
        The duration that you will buy the resource, in month. It is valid when `instance_charge_type` is `PrePaid`.
        Default to 1. Valid values: [1-9, 12, 24, 36]. At present, the provider does not support modify "period" and you can do that via web console.
        """
        __props__['period'] = period

        __self__.ip_address = pulumi.runtime.UNKNOWN
        """
        The elastic ip address
        """
        __self__.status = pulumi.runtime.UNKNOWN
        """
        The EIP current status.
        """

        super(Eip, __self__).__init__(
            'alicloud:ecs/eip:Eip',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'bandwidth' in outs:
            self.bandwidth = outs['bandwidth']
        if 'description' in outs:
            self.description = outs['description']
        if 'instance' in outs:
            self.instance = outs['instance']
        if 'instanceChargeType' in outs:
            self.instance_charge_type = outs['instanceChargeType']
        if 'internetChargeType' in outs:
            self.internet_charge_type = outs['internetChargeType']
        if 'ipAddress' in outs:
            self.ip_address = outs['ipAddress']
        if 'name' in outs:
            self.name = outs['name']
        if 'period' in outs:
            self.period = outs['period']
        if 'status' in outs:
            self.status = outs['status']
