# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class EipAssociation(pulumi.CustomResource):
    """
    Provides an Alicloud EIP Association resource for associating Elastic IP to ECS Instance, SLB Instance or Nat Gateway.
    
    ~> **NOTE:** `alicloud_eip_association` is useful in scenarios where EIPs are either
     pre-existing or distributed to customers or users and therefore cannot be changed.
    
    ~> **NOTE:** From version 1.7.1, the resource support to associate EIP to SLB Instance or Nat Gateway.
    
    ~> **NOTE:** One EIP can only be associated with ECS or SLB instance which in the VPC.
    """
    def __init__(__self__, __name__, __opts__=None, allocation_id=None, instance_id=None):
        """Create a EipAssociation resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if allocation_id and not isinstance(allocation_id, basestring):
            raise TypeError('Expected property allocation_id to be a basestring')
        __self__.allocation_id = allocation_id
        """
        The allocation EIP ID.
        """
        __props__['allocationId'] = allocation_id

        if instance_id and not isinstance(instance_id, basestring):
            raise TypeError('Expected property instance_id to be a basestring')
        __self__.instance_id = instance_id
        """
        The ID of the ECS or SLB instance or Nat Gateway.
        """
        __props__['instanceId'] = instance_id

        super(EipAssociation, __self__).__init__(
            'alicloud:ecs/eipAssociation:EipAssociation',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'allocationId' in outs:
            self.allocation_id = outs['allocationId']
        if 'instanceId' in outs:
            self.instance_id = outs['instanceId']
