# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class KeyPair(pulumi.CustomResource):
    """
    Provides a key pair resource.
    """
    def __init__(__self__, __name__, __opts__=None, key_file=None, key_name=None, key_name_prefix=None, public_key=None):
        """Create a KeyPair resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if key_file and not isinstance(key_file, basestring):
            raise TypeError('Expected property key_file to be a basestring')
        __self__.key_file = key_file
        """
        The name of file to save your new key pair's private key. Strongly suggest you to specified it when you creating key pair, otherwise, you wouldn't get its private key ever.
        """
        __props__['keyFile'] = key_file

        if key_name and not isinstance(key_name, basestring):
            raise TypeError('Expected property key_name to be a basestring')
        __self__.key_name = key_name
        """
        The key pair's name. It is the only in one Alicloud account.
        """
        __props__['keyName'] = key_name

        if key_name_prefix and not isinstance(key_name_prefix, basestring):
            raise TypeError('Expected property key_name_prefix to be a basestring')
        __self__.key_name_prefix = key_name_prefix
        """
        The key pair name's prefix. It is conflict with `key_name`. If it is specified, terraform will using it to build the only key name.
        """
        __props__['keyNamePrefix'] = key_name_prefix

        if public_key and not isinstance(public_key, basestring):
            raise TypeError('Expected property public_key to be a basestring')
        __self__.public_key = public_key
        """
        You can import an existing public key and using Alicloud key pair to manage it.
        """
        __props__['publicKey'] = public_key

        __self__.finger_print = pulumi.runtime.UNKNOWN

        super(KeyPair, __self__).__init__(
            'alicloud:ecs/keyPair:KeyPair',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'fingerPrint' in outs:
            self.finger_print = outs['fingerPrint']
        if 'keyFile' in outs:
            self.key_file = outs['keyFile']
        if 'keyName' in outs:
            self.key_name = outs['keyName']
        if 'keyNamePrefix' in outs:
            self.key_name_prefix = outs['keyNamePrefix']
        if 'publicKey' in outs:
            self.public_key = outs['publicKey']
