# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class Attachment(pulumi.CustomResource):
    """
    Attaches several ECS instances to a specified scaling group or remove them from it.
    
    ~> **NOTE:** ECS instances can be attached or remove only when the scaling group is active and it has no scaling activity in progress.
    
    ~> **NOTE:** There are two types ECS instances in a scaling group: "AutoCreated" and "Attached". The total number of them can not larger than the scaling group "MaxSize".
    """
    def __init__(__self__, __name__, __opts__=None, force=None, instance_ids=None, scaling_group_id=None):
        """Create a Attachment resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if force and not isinstance(force, bool):
            raise TypeError('Expected property force to be a bool')
        __self__.force = force
        """
        Whether to remove forcibly "AutoCreated" ECS instances in order to release scaling group capacity "MaxSize" for attaching ECS instances. Default to false.
        """
        __props__['force'] = force

        if not instance_ids:
            raise TypeError('Missing required property instance_ids')
        elif not isinstance(instance_ids, list):
            raise TypeError('Expected property instance_ids to be a list')
        __self__.instance_ids = instance_ids
        """
        ID of the ECS instance to be attached to the scaling group. You can input up to 20 IDs.
        """
        __props__['instanceIds'] = instance_ids

        if not scaling_group_id:
            raise TypeError('Missing required property scaling_group_id')
        elif not isinstance(scaling_group_id, basestring):
            raise TypeError('Expected property scaling_group_id to be a basestring')
        __self__.scaling_group_id = scaling_group_id
        """
        ID of the scaling group of a scaling configuration.
        """
        __props__['scalingGroupId'] = scaling_group_id

        super(Attachment, __self__).__init__(
            'alicloud:ess/attachment:Attachment',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'force' in outs:
            self.force = outs['force']
        if 'instanceIds' in outs:
            self.instance_ids = outs['instanceIds']
        if 'scalingGroupId' in outs:
            self.scaling_group_id = outs['scalingGroupId']
