# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class Service(pulumi.CustomResource):
    """
    Provides a Alicloud Function Compute Service resource. The resource is the base of launching Function and Trigger configuration.
     For information about Service and how to use it, see [What is Function Compute](https://www.alibabacloud.com/help/doc-detail/52895.htm).
    
    -> **NOTE:** The resource requires a provider field 'account_id'. [See account_id](https://www.terraform.io/docs/providers/alicloud/index.html#account_id).
    
    -> **NOTE:** If you happen the error "Argument 'internetAccess' is not supported", you need to log on web console and click button "Apply VPC Function"
    which is in the upper of [Function Service Web Console](https://fc.console.aliyun.com/) page.
    """
    def __init__(__self__, __name__, __opts__=None, description=None, internet_access=None, log_config=None, name=None, name_prefix=None, role=None, vpc_config=None):
        """Create a Service resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if description and not isinstance(description, basestring):
            raise TypeError('Expected property description to be a basestring')
        __self__.description = description
        """
        The function compute service description.
        """
        __props__['description'] = description

        if internet_access and not isinstance(internet_access, bool):
            raise TypeError('Expected property internet_access to be a bool')
        __self__.internet_access = internet_access
        """
        Whether to allow the service to access Internet. Default to "true".
        """
        __props__['internetAccess'] = internet_access

        if log_config and not isinstance(log_config, dict):
            raise TypeError('Expected property log_config to be a dict')
        __self__.log_config = log_config
        """
        Provide this to store your FC service logs. Fields documented below. See [Create a Service](https://www.alibabacloud.com/help/doc-detail/51924.htm).
        """
        __props__['logConfig'] = log_config

        if name and not isinstance(name, basestring):
            raise TypeError('Expected property name to be a basestring')
        __self__.name = name
        """
        The Function Compute service name. It is the only in one Alicloud account and is conflict with "name_prefix".
        """
        __props__['name'] = name

        if name_prefix and not isinstance(name_prefix, basestring):
            raise TypeError('Expected property name_prefix to be a basestring')
        __self__.name_prefix = name_prefix
        """
        Setting a prefix to get a only name. It is conflict with "name".
        """
        __props__['namePrefix'] = name_prefix

        if role and not isinstance(role, basestring):
            raise TypeError('Expected property role to be a basestring')
        __self__.role = role
        """
        RAM role arn attached to the Function Compute service. This governs both who / what can invoke your Function, as well as what resources our Function has access to. See [User Permissions](https://www.alibabacloud.com/help/doc-detail/52885.htm) for more details.
        """
        __props__['role'] = role

        if vpc_config and not isinstance(vpc_config, dict):
            raise TypeError('Expected property vpc_config to be a dict')
        __self__.vpc_config = vpc_config
        """
        Provide this to allow your FC service to access your VPC. Fields documented below. See [Function Compute Service in VPC](https://www.alibabacloud.com/help/faq-detail/72959.htm).
        """
        __props__['vpcConfig'] = vpc_config

        __self__.last_modified = pulumi.runtime.UNKNOWN
        """
        The date this resource was last modified.
        """

        super(Service, __self__).__init__(
            'alicloud:fc/service:Service',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'description' in outs:
            self.description = outs['description']
        if 'internetAccess' in outs:
            self.internet_access = outs['internetAccess']
        if 'lastModified' in outs:
            self.last_modified = outs['lastModified']
        if 'logConfig' in outs:
            self.log_config = outs['logConfig']
        if 'name' in outs:
            self.name = outs['name']
        if 'namePrefix' in outs:
            self.name_prefix = outs['namePrefix']
        if 'role' in outs:
            self.role = outs['role']
        if 'vpcConfig' in outs:
            self.vpc_config = outs['vpcConfig']
