# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class Key(pulumi.CustomResource):
    """
    A kms key can help user to protect data security in the transmission process.
    """
    def __init__(__self__, __name__, __opts__=None, deletion_window_in_days=None, description=None, is_enabled=None, key_usage=None):
        """Create a Key resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if deletion_window_in_days and not isinstance(deletion_window_in_days, int):
            raise TypeError('Expected property deletion_window_in_days to be a int')
        __self__.deletion_window_in_days = deletion_window_in_days
        """
        Duration in days after which the key is deleted
        after destruction of the resource, must be between 7 and 30 days. Defaults to 30 days.
        """
        __props__['deletionWindowInDays'] = deletion_window_in_days

        if description and not isinstance(description, basestring):
            raise TypeError('Expected property description to be a basestring')
        __self__.description = description
        """
        The description of the key as viewed in Alicloud console. Default to "From Terraform".
        """
        __props__['description'] = description

        if is_enabled and not isinstance(is_enabled, bool):
            raise TypeError('Expected property is_enabled to be a bool')
        __self__.is_enabled = is_enabled
        """
        Specifies whether the key is enabled. Defaults to true.
        """
        __props__['isEnabled'] = is_enabled

        if key_usage and not isinstance(key_usage, basestring):
            raise TypeError('Expected property key_usage to be a basestring')
        __self__.key_usage = key_usage
        """
        Specifies the usage of CMK. Currently, default to 'ENCRYPT/DECRYPT', indicating that CMK is used for encryption and decryption.
        """
        __props__['keyUsage'] = key_usage

        __self__.arn = pulumi.runtime.UNKNOWN
        """
        The Alicloud Resource Name (ARN) of the key.
        """

        super(Key, __self__).__init__(
            'alicloud:kms/key:Key',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'arn' in outs:
            self.arn = outs['arn']
        if 'deletionWindowInDays' in outs:
            self.deletion_window_in_days = outs['deletionWindowInDays']
        if 'description' in outs:
            self.description = outs['description']
        if 'isEnabled' in outs:
            self.is_enabled = outs['isEnabled']
        if 'keyUsage' in outs:
            self.key_usage = outs['keyUsage']
