# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class Store(pulumi.CustomResource):
    """
    The log store is a unit in Log Service to collect, store, and query the log data. Each log store belongs to a project,
    and each project can create multiple Logstores. [Refer to details](https://www.alibabacloud.com/help/doc-detail/48874.htm)
    """
    def __init__(__self__, __name__, __opts__=None, name=None, project=None, retention_period=None, shard_count=None):
        """Create a Store resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if name and not isinstance(name, basestring):
            raise TypeError('Expected property name to be a basestring')
        __self__.name = name
        """
        The log store, which is unique in the same project.
        """
        __props__['name'] = name

        if not project:
            raise TypeError('Missing required property project')
        elif not isinstance(project, basestring):
            raise TypeError('Expected property project to be a basestring')
        __self__.project = project
        """
        The project name to the log store belongs.
        """
        __props__['project'] = project

        if retention_period and not isinstance(retention_period, int):
            raise TypeError('Expected property retention_period to be a int')
        __self__.retention_period = retention_period
        """
        The data retention time (in days). Valid values: [1-3650]. Default to 30. Log store data will be stored permanently when the value is "3650".
        """
        __props__['retentionPeriod'] = retention_period

        if shard_count and not isinstance(shard_count, int):
            raise TypeError('Expected property shard_count to be a int')
        __self__.shard_count = shard_count
        """
        The number of shards in this log store. Default to 2. You can modify it by "Split" or "Merge" operations. [Refer to details](https://www.alibabacloud.com/help/doc-detail/28976.htm)
        """
        __props__['shardCount'] = shard_count

        __self__.shards = pulumi.runtime.UNKNOWN

        super(Store, __self__).__init__(
            'alicloud:log/store:Store',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'name' in outs:
            self.name = outs['name']
        if 'project' in outs:
            self.project = outs['project']
        if 'retentionPeriod' in outs:
            self.retention_period = outs['retentionPeriod']
        if 'shardCount' in outs:
            self.shard_count = outs['shardCount']
        if 'shards' in outs:
            self.shards = outs['shards']
