# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class Queue(pulumi.CustomResource):
    def __init__(__self__, __name__, __opts__=None, delay_seconds=None, maximum_message_size=None, message_retention_period=None, name=None, polling_wait_seconds=None, visibility_timeout=None):
        """Create a Queue resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if delay_seconds and not isinstance(delay_seconds, int):
            raise TypeError('Expected property delay_seconds to be a int')
        __self__.delay_seconds = delay_seconds
        """
        This attribute defines the length of time, in seconds, after which every message sent to the queue is dequeued. Valid value range: 0-604800 seconds, i.e., 0 to 7 days. Default value to 0.
        """
        __props__['delaySeconds'] = delay_seconds

        if maximum_message_size and not isinstance(maximum_message_size, int):
            raise TypeError('Expected property maximum_message_size to be a int')
        __self__.maximum_message_size = maximum_message_size
        """
        This indicates the maximum length, in bytes, of any message body sent to the queue. Valid value range: 1024-65536, i.e., 1K to 64K. Default value to 65536.
        """
        __props__['maximumMessageSize'] = maximum_message_size

        if message_retention_period and not isinstance(message_retention_period, int):
            raise TypeError('Expected property message_retention_period to be a int')
        __self__.message_retention_period = message_retention_period
        """
        Messages are deleted from the queue after a specified length of time, whether they have been activated or not. This attribute defines the viability period, in seconds, for every message in the queue. Valid value range: 60-604800 seconds, i.e., 1 minutes to 7 days. Default value to 345600.
        """
        __props__['messageRetentionPeriod'] = message_retention_period

        if name and not isinstance(name, basestring):
            raise TypeError('Expected property name to be a basestring')
        __self__.name = name
        """
        Two queues on a single account in the same region cannot have the same name. A queue name must start with an English letter or a digit, and can contain English letters, digits, and hyphens, with the length not exceeding 256 characters .
        """
        __props__['name'] = name

        if polling_wait_seconds and not isinstance(polling_wait_seconds, int):
            raise TypeError('Expected property polling_wait_seconds to be a int')
        __self__.polling_wait_seconds = polling_wait_seconds
        """
        Long polling is measured in seconds. When this attribute is set to 0, long polling is disabled. When it is not set to 0, long polling is enabled and message dequeue requests will be processed only when valid messages are received or when long polling times out. Valid value range: 0-30 seconds. Default value to 0.
        """
        __props__['pollingWaitSeconds'] = polling_wait_seconds

        if visibility_timeout and not isinstance(visibility_timeout, int):
            raise TypeError('Expected property visibility_timeout to be a int')
        __self__.visibility_timeout = visibility_timeout
        """
        The VisibilityTimeout attribute of the queue. A dequeued messages will change from active (visible) status to inactive (invisible) status, and this attribute defines the length of time, in seconds, that messages remain invisible. Messages return to active status after the set period. Valid value range: 1-43200 seconds, i.e., 1 seconds to 12 hours. Default value to 30.
        """
        __props__['visibilityTimeout'] = visibility_timeout

        super(Queue, __self__).__init__(
            'alicloud:mns/queue:Queue',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'delaySeconds' in outs:
            self.delay_seconds = outs['delaySeconds']
        if 'maximumMessageSize' in outs:
            self.maximum_message_size = outs['maximumMessageSize']
        if 'messageRetentionPeriod' in outs:
            self.message_retention_period = outs['messageRetentionPeriod']
        if 'name' in outs:
            self.name = outs['name']
        if 'pollingWaitSeconds' in outs:
            self.polling_wait_seconds = outs['pollingWaitSeconds']
        if 'visibilityTimeout' in outs:
            self.visibility_timeout = outs['visibilityTimeout']
