# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class Table(pulumi.CustomResource):
    """
    Provides an OTS table resource.
    
    ~> **NOTE:** From Provider version 1.10.0, the provider field 'ots_instance_name' has been deprecated and
    you should use resource alicloud_ots_table's new field 'instance_name' and 'table_name' to re-import this resource.
    """
    def __init__(__self__, __name__, __opts__=None, instance_name=None, max_version=None, primary_keys=None, table_name=None, time_to_live=None):
        """Create a Table resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not instance_name:
            raise TypeError('Missing required property instance_name')
        elif not isinstance(instance_name, basestring):
            raise TypeError('Expected property instance_name to be a basestring')
        __self__.instance_name = instance_name
        """
        The name of the OTS instance in which table will located.
        """
        __props__['instanceName'] = instance_name

        if not max_version:
            raise TypeError('Missing required property max_version')
        elif not isinstance(max_version, int):
            raise TypeError('Expected property max_version to be a int')
        __self__.max_version = max_version
        """
        The maximum number of versions stored in this table. The valid value is 1-2147483647.
        """
        __props__['maxVersion'] = max_version

        if not primary_keys:
            raise TypeError('Missing required property primary_keys')
        elif not isinstance(primary_keys, list):
            raise TypeError('Expected property primary_keys to be a list')
        __self__.primary_keys = primary_keys
        """
        The property of `TableMeta` which indicates the structure information of a table. It describes the attribute value of primary key. The number of `primary_key` should not be less than one and not be more than four.
        """
        __props__['primaryKeys'] = primary_keys

        if not table_name:
            raise TypeError('Missing required property table_name')
        elif not isinstance(table_name, basestring):
            raise TypeError('Expected property table_name to be a basestring')
        __self__.table_name = table_name
        """
        The table name of the OTS instance. If changed, a new table would be created.
        """
        __props__['tableName'] = table_name

        if not time_to_live:
            raise TypeError('Missing required property time_to_live')
        elif not isinstance(time_to_live, int):
            raise TypeError('Expected property time_to_live to be a int')
        __self__.time_to_live = time_to_live
        """
        The retention time of data stored in this table (unit: second). The value maximum is 2147483647 and -1 means never expired.
        """
        __props__['timeToLive'] = time_to_live

        super(Table, __self__).__init__(
            'alicloud:ots/table:Table',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'instanceName' in outs:
            self.instance_name = outs['instanceName']
        if 'maxVersion' in outs:
            self.max_version = outs['maxVersion']
        if 'primaryKeys' in outs:
            self.primary_keys = outs['primaryKeys']
        if 'tableName' in outs:
            self.table_name = outs['tableName']
        if 'timeToLive' in outs:
            self.time_to_live = outs['timeToLive']
