# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class LoginProfile(pulumi.CustomResource):
    """
    Provides a RAM User Login Profile resource.
    
    """
    def __init__(__self__, __name__, __opts__=None, mfa_bind_required=None, password=None, password_reset_required=None, user_name=None):
        """Create a LoginProfile resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if mfa_bind_required and not isinstance(mfa_bind_required, bool):
            raise TypeError('Expected property mfa_bind_required to be a bool')
        __self__.mfa_bind_required = mfa_bind_required
        """
        This parameter indicates whether the MFA needs to be bind when the user first logs in. Default value is `false`.
        """
        __props__['mfaBindRequired'] = mfa_bind_required

        if not password:
            raise TypeError('Missing required property password')
        elif not isinstance(password, basestring):
            raise TypeError('Expected property password to be a basestring')
        __self__.password = password
        """
        Password of the RAM user.
        """
        __props__['password'] = password

        if password_reset_required and not isinstance(password_reset_required, bool):
            raise TypeError('Expected property password_reset_required to be a bool')
        __self__.password_reset_required = password_reset_required
        """
        This parameter indicates whether the password needs to be reset when the user first logs in. Default value is `false`.
        """
        __props__['passwordResetRequired'] = password_reset_required

        if not user_name:
            raise TypeError('Missing required property user_name')
        elif not isinstance(user_name, basestring):
            raise TypeError('Expected property user_name to be a basestring')
        __self__.user_name = user_name
        """
        Name of the RAM user. This name can have a string of 1 to 64 characters, must contain only alphanumeric characters or hyphens, such as "-",".","_", and must not begin with a hyphen.
        """
        __props__['userName'] = user_name

        super(LoginProfile, __self__).__init__(
            'alicloud:ram/loginProfile:LoginProfile',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'mfaBindRequired' in outs:
            self.mfa_bind_required = outs['mfaBindRequired']
        if 'password' in outs:
            self.password = outs['password']
        if 'passwordResetRequired' in outs:
            self.password_reset_required = outs['passwordResetRequired']
        if 'userName' in outs:
            self.user_name = outs['userName']
