# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class User(pulumi.CustomResource):
    """
    Provides a RAM User resource.
    
    ~> **NOTE:** When you want to destroy this resource forcefully(means release all the relationships associated with it automatically and then destroy it) without set `force`  with `true` at beginning, you need add `force = true` to configuration file and run `terraform plan`, then you can delete resource forcefully.
    """
    def __init__(__self__, __name__, __opts__=None, comments=None, display_name=None, email=None, force=None, mobile=None, name=None):
        """Create a User resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if comments and not isinstance(comments, basestring):
            raise TypeError('Expected property comments to be a basestring')
        __self__.comments = comments
        """
        Comment of the RAM user. This parameter can have a string of 1 to 128 characters.
        """
        __props__['comments'] = comments

        if display_name and not isinstance(display_name, basestring):
            raise TypeError('Expected property display_name to be a basestring')
        __self__.display_name = display_name
        """
        Name of the RAM user which for display. This name can have a string of 1 to 12 characters or Chinese characters, must contain only alphanumeric characters or Chinese characters or hyphens, such as "-",".", and must not end with a hyphen.
        """
        __props__['displayName'] = display_name

        if email and not isinstance(email, basestring):
            raise TypeError('Expected property email to be a basestring')
        __self__.email = email
        """
        Email of the RAM user.
        """
        __props__['email'] = email

        if force and not isinstance(force, bool):
            raise TypeError('Expected property force to be a bool')
        __self__.force = force
        """
        This parameter is used for resource destroy. Default value is `false`.
        """
        __props__['force'] = force

        if mobile and not isinstance(mobile, basestring):
            raise TypeError('Expected property mobile to be a basestring')
        __self__.mobile = mobile
        """
        Phone number of the RAM user. This number must contain an international area code prefix, just look like this: 86-18600008888.
        """
        __props__['mobile'] = mobile

        if name and not isinstance(name, basestring):
            raise TypeError('Expected property name to be a basestring')
        __self__.name = name
        """
        Name of the RAM user. This name can have a string of 1 to 64 characters, must contain only alphanumeric characters or hyphens, such as "-",".","_", and must not begin with a hyphen.
        """
        __props__['name'] = name

        super(User, __self__).__init__(
            'alicloud:ram/user:User',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'comments' in outs:
            self.comments = outs['comments']
        if 'displayName' in outs:
            self.display_name = outs['displayName']
        if 'email' in outs:
            self.email = outs['email']
        if 'force' in outs:
            self.force = outs['force']
        if 'mobile' in outs:
            self.mobile = outs['mobile']
        if 'name' in outs:
            self.name = outs['name']
