# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class Connection(pulumi.CustomResource):
    """
    Provides an RDS connection resource to allocate an Internet connection string for RDS instance.
    
    ~> **NOTE:** Each RDS instance will allocate a intranet connnection string automatically and its prifix is RDS instance ID.
     To avoid unnecessary conflict, please specified a internet connection prefix before applying the resource.
    """
    def __init__(__self__, __name__, __opts__=None, connection_prefix=None, instance_id=None, port=None):
        """Create a Connection resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if connection_prefix and not isinstance(connection_prefix, basestring):
            raise TypeError('Expected property connection_prefix to be a basestring')
        __self__.connection_prefix = connection_prefix
        """
        Prefix of an Internet connection string. It must be checked for uniqueness. It may consist of lowercase letters, numbers, and underlines, and must start with a letter and have no more than 30 characters. Default to <instance_id> + 'tf'.
        """
        __props__['connectionPrefix'] = connection_prefix

        if not instance_id:
            raise TypeError('Missing required property instance_id')
        elif not isinstance(instance_id, basestring):
            raise TypeError('Expected property instance_id to be a basestring')
        __self__.instance_id = instance_id
        """
        The Id of instance that can run database.
        """
        __props__['instanceId'] = instance_id

        if port and not isinstance(port, basestring):
            raise TypeError('Expected property port to be a basestring')
        __self__.port = port
        """
        Internet connection port. Valid value: [3001-3999]. Default to 3306.
        """
        __props__['port'] = port

        __self__.connection_string = pulumi.runtime.UNKNOWN
        """
        Connection instance string.
        """
        __self__.ip_address = pulumi.runtime.UNKNOWN
        """
        The ip address of connection string.
        """

        super(Connection, __self__).__init__(
            'alicloud:rds/connection:Connection',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'connectionPrefix' in outs:
            self.connection_prefix = outs['connectionPrefix']
        if 'connectionString' in outs:
            self.connection_string = outs['connectionString']
        if 'instanceId' in outs:
            self.instance_id = outs['instanceId']
        if 'ipAddress' in outs:
            self.ip_address = outs['ipAddress']
        if 'port' in outs:
            self.port = outs['port']
