# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class Acl(pulumi.CustomResource):
    """
    An access control list contains multiple IP addresses or CIDR blocks.
    The access control list can help you to define multiple instance listening dimension,
    and to meet the multiple usage for single access control list.
    
    Server Load Balancer allows you to configure access control for listeners.
    You can configure different whitelists or blacklists for different listeners.
    
    You can configure access control
    when you create a listener or change access control configuration after a listener is created.
    
    ~> **NOTE:** One access control list can be attached to many Listeners in different load balancer as whitelists or blacklists.
    
    ~> **NOTE:** The maximum number of access control lists per region  is 50.
    
    ~> **NOTE:** The maximum number of IP addresses added each time is 50.
    
    ~> **NOTE:** The maximum number of entries per access control list is 300.
    
    ~> **NOTE:** The maximum number of listeners that an access control list can be added to is 50.
    
    For information about slb and how to use it, see [What is Server Load Balancer](https://www.alibabacloud.com/help/doc-detail/27539.htm).
    
    For information about acl and how to use it, see [Configure an access control list](https://www.alibabacloud.com/help/doc-detail/85978.htm).
    
    """
    def __init__(__self__, __name__, __opts__=None, entry_lists=None, ip_version=None, name=None):
        """Create a Acl resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if entry_lists and not isinstance(entry_lists, list):
            raise TypeError('Expected property entry_lists to be a list')
        __self__.entry_lists = entry_lists
        """
        A list of entry (IP addresses or CIDR blocks) to be added. At most 50 etnry can be supported in one resource. It contains two sub-fields as `Entry Block` follows.
        """
        __props__['entryLists'] = entry_lists

        if ip_version and not isinstance(ip_version, basestring):
            raise TypeError('Expected property ip_version to be a basestring')
        __self__.ip_version = ip_version
        """
        The IP Version of access control list is the type of its entry (IP addresses or CIDR blocks). It values ipv4/ipv6. Our plugin provides a default ip_version: "ipv4".
        """
        __props__['ipVersion'] = ip_version

        if name and not isinstance(name, basestring):
            raise TypeError('Expected property name to be a basestring')
        __self__.name = name
        """
        Name of the access control list.
        """
        __props__['name'] = name

        super(Acl, __self__).__init__(
            'alicloud:slb/acl:Acl',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'entryLists' in outs:
            self.entry_lists = outs['entryLists']
        if 'ipVersion' in outs:
            self.ip_version = outs['ipVersion']
        if 'name' in outs:
            self.name = outs['name']
