# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class NatGateway(pulumi.CustomResource):
    """
    Provides a resource to create a VPC NAT Gateway.
    
    
    ~> **NOTE:** Resource bandwidth packages will not be supported since 00:00 on November 4, 2017, and public IP can be replaced be elastic IPs.
    If a Nat Gateway has already bought some bandwidth packages, it can not bind elastic IP and you have to submit the [work order](https://selfservice.console.aliyun.com/ticket/createIndex) to solve.
    If you want to add public IP, you can use resource 'alicloud_eip_association' to bind several elastic IPs for one Nat Gateway.
    
    ~> **NOTE:** From version 1.7.1, this resource has deprecated bandwidth packages.
    But, in order to manage stock bandwidth packages, version 1.13.0 re-support configuring 'bandwidth_packages'.
    
    """
    def __init__(__self__, __name__, __opts__=None, bandwidth_packages=None, description=None, name=None, spec=None, specification=None, vpc_id=None):
        """Create a NatGateway resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if bandwidth_packages and not isinstance(bandwidth_packages, list):
            raise TypeError('Expected property bandwidth_packages to be a list')
        __self__.bandwidth_packages = bandwidth_packages
        """
        A list of bandwidth packages for the nat gatway. Only support nat gateway created before 00:00 on November 4, 2017. Available in v1.13.0+ and v1.7.1-.
        """
        __props__['bandwidthPackages'] = bandwidth_packages

        if description and not isinstance(description, basestring):
            raise TypeError('Expected property description to be a basestring')
        __self__.description = description
        """
        Description of the nat gateway, This description can have a string of 2 to 256 characters, It cannot begin with http:// or https://. Defaults to null.
        """
        __props__['description'] = description

        if name and not isinstance(name, basestring):
            raise TypeError('Expected property name to be a basestring')
        __self__.name = name
        """
        Name of the nat gateway. The value can have a string of 2 to 128 characters, must contain only alphanumeric characters or hyphens, such as "-",".","_", and must not begin or end with a hyphen, and must not begin with http:// or https://. Defaults to null.
        """
        __props__['name'] = name

        if spec and not isinstance(spec, basestring):
            raise TypeError('Expected property spec to be a basestring')
        __self__.spec = spec
        """
        It has been deprecated from provider version 1.7.1, and new field 'specification' can replace it.
        """
        __props__['spec'] = spec

        if specification and not isinstance(specification, basestring):
            raise TypeError('Expected property specification to be a basestring')
        __self__.specification = specification
        """
        The specification of the nat gateway. Valid values are `Small`, `Middle` and `Large`. Default to `Small`. Details refer to [Nat Gateway Specification](https://www.alibabacloud.com/help/doc-detail/42757.htm).
        """
        __props__['specification'] = specification

        if not vpc_id:
            raise TypeError('Missing required property vpc_id')
        elif not isinstance(vpc_id, basestring):
            raise TypeError('Expected property vpc_id to be a basestring')
        __self__.vpc_id = vpc_id
        """
        The VPC ID.
        """
        __props__['vpcId'] = vpc_id

        __self__.bandwidth_package_ids = pulumi.runtime.UNKNOWN
        """
        A list ID of the bandwidth packages, and split them with commas
        """
        __self__.forward_table_ids = pulumi.runtime.UNKNOWN
        """
        The nat gateway will auto create a snap and forward item, the `forward_table_ids` is the created one.
        """
        __self__.snat_table_ids = pulumi.runtime.UNKNOWN
        """
        The nat gateway will auto create a snap and forward item, the `snat_table_ids` is the created one.
        """

        super(NatGateway, __self__).__init__(
            'alicloud:vpc/natGateway:NatGateway',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'bandwidthPackageIds' in outs:
            self.bandwidth_package_ids = outs['bandwidthPackageIds']
        if 'bandwidthPackages' in outs:
            self.bandwidth_packages = outs['bandwidthPackages']
        if 'description' in outs:
            self.description = outs['description']
        if 'forwardTableIds' in outs:
            self.forward_table_ids = outs['forwardTableIds']
        if 'name' in outs:
            self.name = outs['name']
        if 'snatTableIds' in outs:
            self.snat_table_ids = outs['snatTableIds']
        if 'spec' in outs:
            self.spec = outs['spec']
        if 'specification' in outs:
            self.specification = outs['specification']
        if 'vpcId' in outs:
            self.vpc_id = outs['vpcId']
